#!/usr/bin/env python3

import sys, base64, urllib.request, urllib.parse, urllib.error, ssl

#import sys, base64, urllib2, ssl

'''
1. Get short description of all devices
url = https://<<FortiSIEM_Supervisor_IP>/phoenix/rest/cmdbDeviceInfo/devices
url = https://<FortiSIEM_Supervisor_IP>/phoenix/rest/cmdbDeviceInfo/devices?organization=ACME

2. Get short description of all devices in an address range
url = https://<FortiSIEM_Supervisor_IP>/phoenix/rest/cmdbDeviceInfo/devices?includeIps=<includeIpSet>&excludeIps=<excludeIpSet>
url = https://<FortiSIEM_Supervisor_IP>/phoenix/rest/cmdbDeviceInfo/devices?organization=ACME&includeIps=<includeIpSet>&excludeIps=<excludeIpSet>

3. Get full information about one devices
url = https://<FortiSIEM_Supervisor_IP>/phoenix/rest/cmdbDeviceInfo/device?ip=<deviceIp>&loadDepend=true
url = https://<FortiSIEM_Supervisor_IP>/phoenix/rest/cmdbDeviceInfo/device?organization=ACME&ip=<deviceIp>&loadDepend=true

4. Get a section of information (Applications, Interfaces, Processors, Storages) about one devices
url = https://<FortiSIEM_Supervisor_IP>/phoenix/rest/cmdbDeviceInfo/device?ip=<deviceIp>&loadDepend=true&fields=<sectionName>
url = https://<FortiSIEM_Supervisor_IP>/phoenix/rest/cmdbDeviceInfo/device?organization=ACME&ip=<deviceIp>&loadDepend=true&fields=<sectionName>
'''


def getCMDBInfo(appServer, user, password):
    base64_bytes = base64.encodebytes((user + ':' + password).encode())
    auth = 'Basic %s' % base64_bytes.decode()

    url = 'https://' + appServer + '/phoenix/rest/cmdbDeviceInfo/devices'
    request = urllib.request.Request(url)
    request.add_header('Authorization', auth.rstrip())
    request.add_header('User-Agent', 'Python-urllib2/2.7')
    request.get_method = lambda: 'GET'
    try:
        ssl._create_default_https_context = ssl._create_unverified_context
        ctx = ssl.SSLContext(ssl.PROTOCOL_TLSv1_2)
        opener = urllib.request.build_opener(urllib.request.HTTPSHandler(debuglevel=False, context=ctx))
        urllib.request.install_opener(opener)
        handle = urllib.request.urlopen(request)
        outXML = handle.read()
        print (outXML.decode())
    except urllib.error.HTTPError as e:
        if (e.code != 204):
            print (e)


if __name__ == '__main__':
    if len(sys.argv) != 4:
        print('Usage: getCMDBInfo.py appServer user password')
        print('Example: python getCMDBInfo.py 192.168.20.116 super/admin adm1n')
        sys.exit()
    getCMDBInfo(sys.argv[1], sys.argv[2], sys.argv[3])
