#!/usr/bin/env python3

import sys, base64, urllib.request, urllib.parse, urllib.error, ssl

def getTriggeringEventIds(appServer, user, password, incidentIds):
    base64_bytes = base64.encodebytes((user + ':' + password).encode())
    auth = 'Basic %s' % base64_bytes.decode()

    url = 'https://' + appServer + '/phoenix/rest/incident/triggeringEvents?incidentIds=' + incidentIds
    request = urllib.request.Request(url)
    request.add_header('Authorization', auth.rstrip())
    request.add_header('User-Agent', 'Python-urllib2/2.7')
    request.get_method = lambda: 'GET'
    try:
        ssl._create_default_https_context = ssl._create_unverified_context
        ctx = ssl.SSLContext(ssl.PROTOCOL_TLSv1_2)
        opener = urllib.request.build_opener(urllib.request.HTTPSHandler(debuglevel=False, context=ctx))
        urllib.request.install_opener(opener)
        handle = urllib.request.urlopen(request)
        outXML = handle.read()
        print (outXML.decode())
    except urllib.error.HTTPError as e:
        if (e.code != 204):
            print (e)


if __name__ == '__main__':
    if len(sys.argv) != 5:
        print('Usage: getTriggeringEventIds.py appServer user password incidentId1,incidentId2')
        print('Example: python getTriggeringEventIds.py 192.168.20.116 super/admin adm1n 200,201')
        sys.exit()
    getTriggeringEventIds(sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4])
