#!/usr/bin/env python3

import sys, base64, urllib.request, urllib.parse, urllib.error, ssl

def addWatchListGroup(appServer, user, password, file):
    f = open(file, 'r')
    content = f.read()
    f.close()
    url = 'https://' + appServer + '/phoenix/rest/watchlist/save'
    base64_bytes = base64.encodebytes((user + ':' + password).encode())
    auth = 'Basic %s' % base64_bytes.decode()

    request = urllib.request.Request(url, content.encode())
    request.add_header('Authorization', auth.rstrip())
    request.add_header('Content-Type', 'text/json')
    request.add_header('Content-Length', len(content))
    request.add_header('User-Agent', 'Python-urllib2/2.7')
    request.get_method = lambda: 'POST'
    try:
        ssl._create_default_https_context = ssl._create_unverified_context
        ctx = ssl.SSLContext(ssl.PROTOCOL_TLSv1_2)
        opener = urllib.request.build_opener(urllib.request.HTTPSHandler(debuglevel=False, context=ctx))
        urllib.request.install_opener(opener)
        handle = urllib.request.urlopen(request)
        outJSON = handle.read()
        print (outJSON.decode() )
        print('Response HTTP Code: %s' % handle.getcode())
    except urllib.error.HTTPError as e:
        if (e.code != 200):
            print (e)


if __name__ == '__main__':
    if len(sys.argv) != 5:
        print('Usage: addWatchListGroup.py appServer user password watchListDefFile')
        print('Example: python addWatchListGroup.py 192.168.20.116 super/admin adm1n watchListDefJSON.json')
        sys.exit()
    addWatchListGroup(sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4])
