#!/usr/bin/env python3

import sys, base64, urllib.request, urllib.parse, urllib.error, ssl


def updateLastSeenTimeByValue(appServer, user, password, groupId, value, orgId, lastSeenTime):
    base64_bytes = base64.encodebytes((user + ':' + password).encode())
    auth = 'Basic %s' % base64_bytes.decode()
    url = 'https://' + appServer + '/phoenix/rest/watchlist/entry/lastseen?lastSeenTime=' + lastSeenTime + '&watchlistId=' + groupId + '&value=' + value + '&custId=' + orgId
    request = urllib.request.Request(url)
    request.add_header('Authorization', auth.rstrip())
    request.add_header('User-Agent', 'Python-urllib2/2.7')
    request.get_method = lambda: 'POST'
    try:
        ssl._create_default_https_context = ssl._create_unverified_context
        ctx = ssl.SSLContext(ssl.PROTOCOL_TLSv1_2)
        opener = urllib.request.build_opener(urllib.request.HTTPSHandler(debuglevel=False, context=ctx))
        urllib.request.install_opener(opener)
        handle = urllib.request.urlopen(request)
        outJSON = handle.read()
        print (outJSON.decode())
        print('Response HTTP Code: %s' % handle.getcode())
    except urllib.error.HTTPError as e:
        if (e.code != 200):
            print (e)


if __name__ == '__main__':
    if len(sys.argv) != 8:
        print('Usage: updateLastSeenTimeByValue.py appServer user password groupId value orgId lastSeenTime')
        print('Example: python updateLastSeenTimeByValue.py 192.168.20.116 super/admin adm1n 500547 10.10.10.1 1 1626967090000')
        sys.exit()
    updateLastSeenTimeByValue(sys.argv[1], sys.argv[2], sys.argv[3], sys.argv[4], sys.argv[5], sys.argv[6], sys.argv[7])
